#include "stdafx.h"
#include "ComHandle.h"
#include "global.h"
#include "RIDBMTReaderDlg.h"
#include <string>
using namespace std;


ComHandle::ComHandle()
{
	m_open = FALSE;

	memset(CommBuf, 0, 1024);
	CommBufLen = 0;
}


int ComHandle::opencom(int portno)
{
	closecom();

	if (portno > 0)
	{
		//½ͨѶ
		m_pSerial = new CMyCESeries();
		m_pSerial->m_OnSeriesRead = OnComRead;
		//m_nPortNo = portNo;


		int rtn = m_pSerial->OpenPort(this, portno);

		//򿪴
		if (rtn)
		{
			addText("򿪴" + std::to_string(portno) + "ɹ");
			m_open = TRUE;
		}
		else
		{
			addText("򿪴" + std::to_string(portno) + "ʧ");
			m_open = FALSE;

			if (m_pSerial)
			{
				delete m_pSerial;
				m_pSerial = NULL;
			}
		}

		return rtn;
	}
	else
		return false;

}


int ComHandle::closecom()
{
	if (m_open && m_pSerial != NULL)
	{
		m_pSerial->ClosePort();

		delete m_pSerial;
		m_pSerial = NULL;

		m_open = FALSE;

		return true;
	}
	return false;
}

int ComHandle::senddata()
{



	//int nRc = m_pSerial->WriteSyncPort(buff, len);
	//return nRc;

	return false;
}

void ComHandle::addText(string str)
{
	if (m_pRichEdit)
	{
		m_pRichEdit->SetSel(-1, -1);

		m_pRichEdit->ReplaceSel((str+ string("\r\n")).c_str());

		m_pRichEdit->PostMessage(WM_VSCROLL, SB_BOTTOM, 0);


		if (m_pRichEdit->GetLineCount() > 500)
		{
			m_pRichEdit->SetSel(0, -1);
			m_pRichEdit->Clear();
		}
	}
}


bool ComHandle::ProcessComData(BYTE* buf, DWORD bufLen)
{


	string s = "";
	char ch[4];
	for (auto i = 0; i < bufLen; ++i)
	{
		sprintf_s(ch, "%.2x ", buf[i]);
		s += ch;
	}

	char chlog[1000];
	sprintf_s(chlog, "յݣ%s", s.data());
	//addText(chlog);


	int ack = 0;
	int recv = 0;
	if (g_enq == 0)
	{
		ack = buf[0];
	}
	else
	{
		recv = 1;


		memcpy(CommBuf + CommBufLen, buf, bufLen);
		CommBufLen += bufLen;

		if (CommBufLen == bufLen)
		{
			if (CommBuf[0] != 0x02)
			{
				addText("ʼλ");
				memset(CommBuf, 0, 1024);
				CommBufLen = 0;
				return 0;
			}


		}

		if (CommBufLen < 5)
		{
			return 0;
		}

		int len = CommBuf[1] * 256 + CommBuf[2];

		if (len + 5 > CommBufLen)
		{
			return 0;
		}
		else if (len + 5 < CommBufLen)
		{
			addText("յܳȳ");
			memset(CommBuf, 0, 1024);
			CommBufLen = 0;
			return 0;
		}
		

		unsigned char xor = XORChecksum(CommBuf, CommBufLen - 1);
		if (xor != CommBuf[CommBufLen - 1])
		{
			addText("յУ鲻");
			g_stage = 0;
			memset(CommBuf, 0, 1024);
			CommBufLen = 0;
			return 0;
		}




		BYTE tbu[128] = { 0 };
		unsigned tle = 0;
		memcpy(tbu, CommBuf, CommBufLen);
		tle = CommBufLen;
		s = "";
		for (auto i = 0; i < tle; ++i)
		{
			sprintf_s(ch, "%.2x ", tbu[i]);
			s += ch;
		}

		sprintf_s(chlog, "յ ϲ%s", s.data());
		//addText(chlog);
	}







	int bsuccess = TRUE;

	if (g_stage == 1)
	{

		if (g_enq == 0)
		{
			if (ack == 0x06)
			{
				unsigned char b[2] = { 0x05 };
				senddata(b, 1);
				g_enq = 1;
			}
			else
			{
				addText("Ӧ𲻳ɹ,code:"+to_string(ack));
				bsuccess = FALSE;
			}

		}
		else
		{
			addText("յѯ״̬ظ");


			if (CommBuf[5] == 0x31)
			{
				addText("޿");
				bsuccess = FALSE;
			}

			if (CommBuf[6] == 0x30)
			{
				addText("޿");
				bsuccess = FALSE;
			}
			else if (CommBuf[6] == 0x3f)
			{
				addText("޷ʶ");
				bsuccess = FALSE;
			}
			else if (CommBuf[6] != 0x31)
			{
				addText("Ǵcpuܻʧ");
			}

		}


		
	}
	else if (g_stage == 2)
	{
		if (g_enq == 0)
		{
			if (ack == 0x06)
			{
				unsigned char b[2] = { 0x05 };
				senddata(b, 1);
				g_enq = 1;
			}
			else
			{
				addText("Ӧ𲻳ɹ,code:" + to_string(ack));
				bsuccess = FALSE;
			}

		}
		else
		{

			addText("յCPU临λظ");


			int result = CommBuf[5];
			if (result == 0x59 || result == 0x5A)
			{
				addText("λɹ");
			}
			else if (result == 0x4E)
			{
				addText("λɹ");
				bsuccess = FALSE;
			}
			else if (result == 0x45)
			{
				addText("޿");
				bsuccess = FALSE;
			}
			else if (result == 0x57)
			{
				addText("λ");
				bsuccess = FALSE;
			}
			else
			{
				addText("޶");
			}
		}

	}
	else if (g_stage >=3 && g_stage <=10)
	{ 
		if (g_enq == 0)
		{
			if (ack == 0x06)
			{
				unsigned char b[2] = { 0x05 };
				senddata(b, 1);
				g_enq = 1;
			}
			else
			{
				addText("Ӧ𲻳ɹ,code:" + to_string(ack));
				bsuccess = FALSE;
			}

		}
		else
		{

			if (g_stage == 3)
			{
				addText("յselect adfظ");

			}
			else if (g_stage == 4)
			{
				addText("յET1ظ");

			}
			else if (g_stage == 5)
			{
				addText("յ21ļظ");

			}
			else if (g_stage == 6)
			{
				addText("յ26ļظ");

			}
			else if (g_stage == 7)
			{
				addText("յverifyظ");

			}
			else if (g_stage == 8)
			{
				int count = CommBuf[8] * 256 + CommBuf[9];


				addText("յѯ¼ֵظ"+to_string(count));



			}
			else if (g_stage == 9)
			{
				int count = CommBuf[8] * 256 + CommBuf[9];
				addText("յѯδ¼ظ" + to_string(count));

			}
			else if (g_stage == 10)
			{
				addText("յ¼ظ");

			}


			int result = CommBuf[5];
			if (result == 0x59)
			{
				addText("ɹ");

				if (g_stage == 8)
				{
					AfxMessageBox("¼ɹ");
				}
			}
			else if (result == 0x4E)
			{
				addText("ɹ");
				bsuccess = FALSE;
			}
			else if (result == 0x45)
			{
				addText("޿");
				bsuccess = FALSE;
			}
			else if (result == 0x57)
			{
				addText("λ");
				bsuccess = FALSE;
			}
			else
			{
				addText("޶");
			}
		}

	}
	else if (g_stage == 11)
	{
		//		
		if (g_enq == 0)
		{
			if (ack == 0x06)
			{
				unsigned char b[2] = { 0x05 };
				senddata(b, 1);
				g_enq = 1;
			}

		}
		else
		{
		}

	}


	if (g_stage == 0)
	{
		//		
		if (g_enq == 0)
		{
			if (ack == 0x06)
			{
				unsigned char b[2] = { 0x05 };
				senddata(b, 1);
				g_enq = 1;
			}

		}
		else
		{
		}
	}


	if (!bsuccess)
	{
		addText("ʧ");
		AfxMessageBox("ʧ");
		g_stage = 0;
		memset(CommBuf, 0, 1024);
		CommBufLen = 0;
		return 0;
	}


	if (g_enq == 1 && recv ==1 && g_stage > 0 && g_stage < 11)
	{
		g_stage++;


		((CRIDBMTReaderDlg*)pParentDlg)->sendStageData();
	}



	memset(CommBuf, 0, 1024);
	CommBufLen = 0;





	return true;
}


void ComHandle::linkRichEdit(CRichEditCtrl* pRichEdit)
{
	m_pRichEdit = pRichEdit;
}


int ComHandle::senddata(const BYTE*buf, DWORD bufLen)
{
	if (!m_open || !m_pSerial)
	{
		addText("δɹ");
		return false;
	}


	int nRc = m_pSerial->WriteSyncPort(buf, bufLen);

	if (nRc)
	{
		CString strS = "";
		for (int i = 0; i < bufLen; ++i)
		{
			CString strW;
			CStringA str;
			strW.Format(_T("%.2x"), buf[i]);
			strS += strW + " ";
		}

		//addText(string(" ͣ") + strS.GetString());
	}
	else
	{
		addText("ʧ");
	}



	return nRc;
}


void ComHandle::setparentdlg(CRIDBMTReaderDlg *pdlg)
{
	pParentDlg = (CDialogEx*)pdlg;
}