#pragma once

#include "MySeries.h"

#include <string>
using std::string;


class CRIDBMTReaderDlg;

class ComHandle
{
public:
	ComHandle();

	int opencom(int portno);

	int closecom();

	int senddata();

	void addText(string str);

	bool ProcessComData(BYTE* buf, DWORD bufLen);

	static void CALLBACK OnComRead(void * pOwner, BYTE* buf, DWORD bufLen)
	{
		if (bufLen <= 1024)
		{
			ComHandle* pThis = (ComHandle*)pOwner;

			pThis->ProcessComData(buf, bufLen);
		}
	}


	void linkRichEdit(CRichEditCtrl* pRichEdit);
	void setparentdlg(CRIDBMTReaderDlg *pdlg);

	int senddata(const BYTE*buf, DWORD bufLen);

	int m_open;

public:
	CDialogEx* pParentDlg;

protected:
	CMyCESeries* m_pSerial;
	CRichEditCtrl* m_pRichEdit;

	BYTE CommBuf[1024];
	unsigned CommBufLen = 0;
	
};


