/*-----------------------------------------
* Copyright (c) 2008 Eric Wong
* ߲οκҵΪ
*
* ļƣ CESeries.cpp
* ļʶ 
* ժҪڷװWINCE ͨѶ
*
* ǰ汾 1.0
* ߣ  Eric Wong
* ڣ 2008117
*
* ȡ汾
* ԭߣ 
* ڣ 
----------------------------------------*/
#include "StdAfx.h"
#include "MySeries.h"

//캯
CMyCESeries::CMyCESeries(UINT portNo, UINT baud, UINT parity, UINT databits, UINT stopbits)
:m_portNo(portNo)
,m_baud(baud)
,m_parity(parity)
,m_databits(databits)
,m_stopbits(stopbits)
,m_hReadThread(NULL)
,m_hReadCloseEvent(NULL)
{
	//m_portNo		= portNo;		//ںʹô1 CANģGPS
	//m_baud			= baud;		//
	//m_parity		= parity;		//żУ,0-None,1-Odd,2-Even
	//m_databits		= databits;		//λ
	//m_stopbits		= stopbits;		//ֹͣλ 0-ֹͣλ11-ֹͣλ1.52-ֹͣλ2

	//ʼڲ
	m_hComm = INVALID_HANDLE_VALUE;
	m_OnSeriesRead = NULL;
	m_hReadCloseEvent = NULL;
	m_bOpened = false;

	bCanComRead		= true;
	m_bSyncOrAsync	= true;//ʹͬʽ첽ʽصʽĬֵΪtrue첽ʽ

	memset(&m_olWrite,0,sizeof(OVERLAPPED));
}

//
CMyCESeries::~CMyCESeries()
{
	if (m_bOpened)
		ClosePort();
}

//ڶ̺߳
DWORD CMyCESeries::ReadThreadFunc(LPVOID lparam)
{
	CMyCESeries *ceSeries = (CMyCESeries*)lparam;
	
	
	BYTE * readBuf = NULL;//ȡֽ
	DWORD actualReadLen=0;//ʵʶȡֽ
	DWORD willReadLen;
	
	DWORD dwReadErrors;
	COMSTAT	cmState;
	//첽ʽ½ʹЩ
	//LPOVERLAPPED 
	OVERLAPPED olWait;
	//memset(&olWaite,0,sizeof(olWaite));  
	memset(&olWait,0,sizeof(OVERLAPPED)); 
    olWait.hEvent = CreateEvent(NULL,TRUE,FALSE,NULL); 
	
	//ͬʽʹøñ
	DWORD	 evtMask;
	


	// ջ壬鴮Ƿ򿪡
	ASSERT(ceSeries->m_hComm !=INVALID_HANDLE_VALUE); 
	
	
	//մ
	PurgeComm(ceSeries->m_hComm, PURGE_RXCLEAR | PURGE_TXCLEAR );
	
	SetCommMask (ceSeries->m_hComm, EV_RXCHAR | EV_CTS | EV_DSR );//3¼
	
	//Բ鿴Щ¼
	//DWORD dwMask1;
	//GetCommMask(ceSeries->m_hComm,&dwMask1);

	OVERLAPPED olRead;
	memset(&olRead,0,sizeof(OVERLAPPED)); 
	olRead.hEvent = CreateEvent(NULL,TRUE,FALSE,NULL);


	while(TRUE)
	{
		if(ceSeries->m_bSyncOrAsync)//첽ʽ
		{
			DWORD dwCommStatus = 0;
			BOOL bWait1=0;
			bWait1= WaitCommEvent(ceSeries->m_hComm,&dwCommStatus,&olWait);//õ3¼κһˣҪǼջʱ
			//while(!bWait1);//ȴWaitCommEventΪTRUEִУַʽвͨصʽ첽ʽʱúһֱΪfalse
			DWORD dwByte; //norains:It is only suitable for the GetOverlappedResult(),not undefined here.
			if(GetOverlappedResult(ceSeries->m_hComm,&olWait,&dwByte,TRUE) == FALSE)//£һֱڸúֱolWaiteеhEvent¼
			//úˣҷֵΪTrue
			{
				 if(GetLastError() != ERROR_IO_PENDING)
				 {
					 return 0x30;
				 }
				 //Clear the error flag
				 DWORD dwErrors;
				 COMSTAT comStat;
				 memset(&comStat,0,sizeof(comStat));
				 ClearCommError(ceSeries->m_hComm,&dwErrors,&comStat);
				 return 0x35;
			}
			
				//ʾյַ		
			if (dwCommStatus & EV_RXCHAR) 
			{
				ClearCommError(ceSeries->m_hComm,&dwReadErrors,&cmState);
				willReadLen = cmState.cbInQue ;
				if (willReadLen <= 0)
				{
					continue;
				}
				
				//첽ʽ
				//ڴ
				readBuf = new BYTE[willReadLen+1];
				ZeroMemory(readBuf,willReadLen+1);
				//ȡ

				//첽ʽ
				if(ReadFile(ceSeries->m_hComm, readBuf, willReadLen, &actualReadLen,&olRead)==FALSE)//첽ڶȡԺ󷵻TRUE
				{
					//ͷڴ
					delete[] readBuf;
					readBuf = NULL;

					if(GetLastError() != ERROR_IO_PENDING)
						return 0x40;

					if(GetOverlappedResult(ceSeries->m_hComm,&olRead,&actualReadLen,TRUE) == FALSE)
						return 0x45;

					if(actualReadLen == 0)
						return 0x50;
				}
				else//еݶȡʱ
				{
					//ȡݴ0
					if (actualReadLen>0)
					{
						//ȡص
						if (ceSeries->m_OnSeriesRead)
						{
							ceSeries->m_OnSeriesRead(ceSeries->m_pOwner,readBuf,actualReadLen);
						}
					}
					//ͷڴ
					delete[] readBuf;
					readBuf = NULL;
				}
			}
			
		}
		else//ͬʽ
		{
				if (WaitCommEvent(ceSeries->m_hComm,&evtMask,0))
				{	
					SetCommMask (ceSeries->m_hComm, EV_RXCHAR | EV_CTS | EV_DSR );
					//ʾյַ
					if (evtMask & EV_RXCHAR)
					{
						ClearCommError(ceSeries->m_hComm,&dwReadErrors,&cmState);
						willReadLen = cmState.cbInQue ;
						if (willReadLen <= 0)
						{
							continue;
						}
						
						//ڴ
						readBuf = new BYTE[willReadLen];
						ZeroMemory(readBuf,willReadLen);
						//ȡ
						ReadFile(ceSeries->m_hComm, readBuf, willReadLen, &actualReadLen,0);
						
						//ȡݴ0
						if (actualReadLen>0)
						{
							//ȡص
							if (ceSeries->m_OnSeriesRead)
							{
								ceSeries->m_OnSeriesRead(ceSeries->m_pOwner,readBuf,actualReadLen);
							}
						}

						//ͷڴ
						delete[] readBuf;
						readBuf = NULL;
					}
				}
		}

		
		
		//ÿζִ߳еôʱȴ߽10milsecondsǷرմ¼Ƿ
		//ClosePort()еCloseHandle(m_hReadCloseEvent);ʹø¼źţҾÿSetEvent(m_hReadCloseEvent)棬úҲʹ¼ź
		//ִClosePotr˵¼Ѿˣڶִ̺߳е˴ʱ
		//while(true),Ӷ˳̣߳
		if (WaitForSingleObject(ceSeries->m_hReadCloseEvent, 10) == WAIT_OBJECT_0)//
		{
			TRACE("߳ReadThreadFunc˳\n");
			break;
		}
	}

	//ر¼
	CloseHandle( olRead.hEvent );
	CloseHandle( olWait.hEvent );

	//ͷڴ
	if(readBuf)
	{
		delete[] readBuf;
		readBuf = NULL;
	}

	ExitThread(0);
	return 0;
}

//رն߳
void CMyCESeries::CloseReadThread()
{
	if( m_hComm != INVALID_HANDLE_VALUE )
	{
	//	SetEvent(m_hReadCloseEvent);
	//	CloseHandle(m_hReadCloseEvent);

		//WaitForSingleObject(m_hReadThread, 1000);

	//	DWORD exitCode;
	//	BOOL ret = GetExitCodeThread(m_hReadThread, &exitCode);
		//if(ret && exitCode != 0)
		{
			TRACE("ǿйرReadThreadFunc߳\n");
			TerminateThread(m_hReadThread,0);
		}
	//	CloseHandle(m_hReadThread);

		m_hReadThread = NULL;
	}

/*
	if( m_hComm != INVALID_HANDLE_VALUE )
	{
		SetEvent(m_hReadCloseEvent);
		//¼Ч
		SetCommMask(m_hComm, 0);
		//нҪ
		PurgeComm( m_hComm,  PURGE_RXCLEAR );
		//ȴ4룬߳û˳ǿ˳
		if (WaitForSingleObject(m_hReadThread,4000) == WAIT_TIMEOUT)
		{
			TerminateThread(m_hReadThread,0);
		}
		m_hReadThread = NULL;
	}
//*/
}


//ܣ򿪴
//ڲpPortOwner	:ʹô˴Ĵ
//		   portNo		:ں
//		   baud			:
//		   parity		:żУ
//		   databits		:λ
//		   stopbits		:ֹͣλ
//ڲ()
//ֵTRUE:ɹ򿪴;FALSE:򿪴ʧ
BOOL CMyCESeries::OpenPort(void * pOwner,
						 UINT portNo	,			//ں
						 UINT baud		,			//
						 UINT parity	,			//żУ
						 UINT databits	,			//λ
						 UINT stopbits  ,				//ֹͣλ
						 bool isASync
						 )
{
	m_portNo		= portNo;		//ںʹô1 CANģGPS
	m_baud			= baud;		//
	m_parity		= parity;		//żУ,0-None,1-Odd,2-Even
	m_databits		= databits;		//λ
	m_stopbits		= stopbits;		//ֹͣλ 0-ֹͣλ11-ֹͣλ1.52-ֹͣλ2

	m_bSyncOrAsync	= isASync;

	DCB commParam;
	TCHAR szPort[15];	

	ASSERT(pOwner!=NULL);
	m_pOwner = pOwner;
	
	// Ѿ򿪵Ļֱӷ
	if (m_hComm != INVALID_HANDLE_VALUE)
	{
		return TRUE;
	}
	
	//ô
	//wsprintf(szPort, _T("\.\COM%d:"), portNo);
	wsprintf(szPort, _T("\\\\.\\COM%d"), portNo);
	//sprintf(szPort, "\\\\.\\COM%d", portNo);
	//򿪴
	
	if(m_bSyncOrAsync)//m_bSyncOrAsyncֵΪ0ͬʽ첽ʽ
	{
			m_hComm = CreateFile(			//첽ʽ
			szPort,
			GENERIC_READ | GENERIC_WRITE,	//д
			0,								//ռʽģʽ
			NULL,
			OPEN_EXISTING,					//򿪶Ǵʽ
			 FILE_FLAG_OVERLAPPED,
			0
			);
	}
	else
	{
		m_hComm = CreateFile(			//ͬʽ
		szPort,
		GENERIC_READ | GENERIC_WRITE,	//д
		0,								//ռʽģʽ
		NULL,
		OPEN_EXISTING,					//򿪶Ǵʽ
		0,  
		NULL
		);
	}


	if (m_hComm == INVALID_HANDLE_VALUE)
	{
		// Ч,ء		
		TRACE(_T("CreateFile Ч\n"));
		DWORD  ErrNo = GetLastError();
		return FALSE;
		
	}
	
	// õ򿪴ڵĵǰԲ޸ĺôڡ
	if (!GetCommState(m_hComm,&commParam))
	{		
		//رմ
		CloseHandle (m_hComm);
		m_hComm = INVALID_HANDLE_VALUE;
		return FALSE;
	}

	if(m_bSyncOrAsync)//첽ʽÿһڶ󣬲ҳɹһڶʱ󣬲ŴһӦķ¼
	{
		 //첽д     
		m_olWrite.hEvent = CreateEvent(NULL,TRUE,FALSE,_T("WriteData"));
//		DWORD dwError = GetLastError();
//		if(dwError !=0)
//		{
//			TRACE("첽ʽڶʱΪôڶд¼ʧ");
//			return FALSE;
//		}
	}
	
	//ôڲ
	commParam.BaudRate = baud;					// ò 
	commParam.fBinary = TRUE;					// öģʽ˴TRUE
	commParam.fParity = TRUE;					// ֧żУ 
	commParam.ByteSize = databits;				// λ,Χ:4-8 
	commParam.Parity = parity;					// Уģʽ
	commParam.StopBits = stopbits;				// ֹͣλ 
	
	commParam.fOutxCtsFlow = FALSE;				// No CTS output flow control 
	commParam.fOutxDsrFlow = FALSE;				// No DSR output flow control 
	commParam.fDtrControl = DTR_CONTROL_ENABLE; 
	// DTR flow control type 
	commParam.fDsrSensitivity = FALSE;			// DSR sensitivity 
	commParam.fTXContinueOnXoff = TRUE;			// XOFF continues Tx 
	commParam.fOutX = FALSE;					// No XON/XOFF out flow control 
	commParam.fInX = FALSE;						// No XON/XOFF in flow control 
	commParam.fErrorChar = FALSE;				// Disable error replacement 
	commParam.fNull = FALSE;					// Disable null stripping 
	commParam.fRtsControl = RTS_CONTROL_ENABLE; 
	// RTS flow control 
	commParam.fAbortOnError = FALSE;			// ڷ󣬲ֹڶд
	
	//ôڲ
	if (!SetCommState(m_hComm, &commParam))
	{
		TRACE(_T("SetCommState error\n"));	
		DWORD dwError = GetLastError();

		//رմ
		CloseHandle (m_hComm);
		m_hComm = INVALID_HANDLE_VALUE;		
		return FALSE;
	}
	
    //ôڶдʱ
	COMMTIMEOUTS CommTimeOuts;
	GetCommTimeouts (m_hComm, &CommTimeOuts);
	CommTimeOuts.ReadIntervalTimeout = MAXDWORD;  
	CommTimeOuts.ReadTotalTimeoutMultiplier = 0;  
	CommTimeOuts.ReadTotalTimeoutConstant = 0;    
	CommTimeOuts.WriteTotalTimeoutMultiplier = 10;  
	CommTimeOuts.WriteTotalTimeoutConstant = 1000;  
	if(!SetCommTimeouts( m_hComm, &CommTimeOuts ))
	{
		TRACE( _T("SetCommTimeouts ش\n") );
		//رմ
		CloseHandle (m_hComm);

		m_hComm = INVALID_HANDLE_VALUE;
		return FALSE;
	}
	
	//ָ˿ڼ¼
	SetCommMask (m_hComm, EV_RXCHAR);
	//䴮豸
	SetupComm(m_hComm,1024,1024);
	//SetupComm(m_hComm,512,512);
	//ʼеϢ
	PurgeComm(m_hComm,PURGE_TXCLEAR|PURGE_RXCLEAR);
	
	CString strEvent;
	strEvent.Format(_T("Com_ReadCloseEvent%d"),portNo);
	m_hReadCloseEvent = CreateEvent(NULL,TRUE,FALSE,strEvent);

	//ڶݼ߳
	if( bCanComRead == true )
	{
		m_hReadThread = CreateThread(NULL,0,ReadThreadFunc,this,0,&m_dwReadThreadID);//ͨthisָ뽫ڶ󴫵ݸ̺߳ReadThreadFuncβ
	}
		
	
	TRACE(_T("%d򿪳ɹ\n"), portNo);
	m_bOpened = true;
	return TRUE;
}



//ܣرմ
//ڲ()
//ڲ()
//ֵ  ()
void CMyCESeries::ClosePort()
{	
	//ʾڻûд
	if (m_hComm == INVALID_HANDLE_VALUE)
		return ;

	//ر¼
	//TRACE("رմڶ¼\n");	
	Sleep(100);
	//رն߳
	CloseReadThread();

	//رմ
	TRACE("CMyCESeriesرմ%d\n", m_portNo);	
	CloseHandle (m_hComm);
	

	//ر¼
	CloseHandle(m_olWrite.hEvent);

	m_hComm = INVALID_HANDLE_VALUE;
	m_bOpened = false;
}


//ܣд
//ڲbuf дݻ
//	       bufLen : д뻺
//ڲ()
//ֵTRUE:óɹ;FALSE:ʧ
BOOL CMyCESeries::WriteSyncPort(const BYTE*buf , DWORD bufLen)
{
	if( false == m_bSyncOrAsync )//ͬʽ
	{
		DWORD dwNumBytesWritten;
		DWORD dwHaveNumWritten =0 ; //Ѿд
		
		int iInc = 0; //3д벻ɹFALSE
		ASSERT(m_hComm != INVALID_HANDLE_VALUE);
		do
		{
			if (WriteFile (m_hComm,					//ھ 
				buf+dwHaveNumWritten,				//дݻ 
				bufLen - dwHaveNumWritten,          //дݻС
				&dwNumBytesWritten,					//ִгɹ󣬷ʵ򴮿дĸ	
				NULL))								//˴NULL
			{
				dwHaveNumWritten = dwHaveNumWritten + dwNumBytesWritten;
				//д
				if (dwHaveNumWritten == bufLen)
				{
					break;
				}
				iInc++;
				if (iInc >= 3)
				{
					TRACE("CMyCESeries::WriteSyncPort ͬдʧ3\n");
					return FALSE;
				}
				Sleep(10);
			}
			else
			{
				TRACE("CMyCESeries::WriteSyncPort ͬдʧ\n");
				return FALSE;
			}
		}while (TRUE);
		
		return TRUE;	
	}
	else//첽ʽ
	{
		DWORD dwNumBytesWritten;
		DWORD dwHaveNumWritten =0 ; //Ѿд

//		OVERLAPPED olWrite;
//		memset(&olWrite,0,sizeof(OVERLAPPED));
//		m_olWrite.hEvent = CreateEvent(NULL,TRUE,FALSE,_T("WriteData"));
		 
		//첽д     
		if (WriteFile (m_hComm,					//ھ 
						buf+dwHaveNumWritten,				//дݻ 
						bufLen - dwHaveNumWritten,          //дݻС
						&dwNumBytesWritten,					//ִгɹ󣬷ʵ򴮿дĸ	
						&m_olWrite) == FALSE)//Ǳʾдʧܣûнд뵽Уֻд˲ֶ
		{
			if(GetLastError() != ERROR_IO_PENDING)
			{
				TRACE("CMyCESeries::WriteSyncPort 첽д0x20\n");
				return 0x20;
			}
			if(GetOverlappedResult(m_hComm,&m_olWrite,&dwNumBytesWritten,TRUE) == FALSE)//ｫһֱֱд뵽Ϊֹ
			{
				TRACE("CMyCESeries::WriteSyncPort 첽д0x25\n");
				return 0x25;
			 }	
		}
		//else//дɹ
		{
			dwHaveNumWritten = dwHaveNumWritten + dwNumBytesWritten;
			//д
			if (dwHaveNumWritten == bufLen)
				return TRUE;
			else
			{
				TRACE("CMyCESeries::WriteSyncPort 첽д%dʧ\n", m_portNo);
				return FALSE;
			}
		}
	}
}


//ܣôڶȡд볬ʱ
//ڲCommTimeOuts : ָCOMMTIMEOUTSṹ
//ڲ()
//ֵTRUE:óɹ;FALSE:ʧ
BOOL CMyCESeries::SetSeriesTimeouts(COMMTIMEOUTS CommTimeOuts)
{
	ASSERT(m_hComm != INVALID_HANDLE_VALUE);
	return SetCommTimeouts(m_hComm,&CommTimeOuts);
}


//õǷ
BOOL CMyCESeries::GetComOpened()
{
	return m_bOpened;
}