
// RIDBMTReaderDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RIDBMTReader.h"
#include "RIDBMTReaderDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CRIDBMTReaderDlg dialog



CRIDBMTReaderDlg::CRIDBMTReaderDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CRIDBMTReaderDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRIDBMTReaderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, CB_Port);
	DDX_Control(pDX, IDC_RICHEDIT21, m_richedit);
}

BEGIN_MESSAGE_MAP(CRIDBMTReaderDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_OpenPort, &CRIDBMTReaderDlg::OnBnClickedButtonOpenport)
	ON_BN_CLICKED(IDC_BUTTON_ClearTrade, &CRIDBMTReaderDlg::OnBnClickedButtonCleartrade)
	ON_BN_CLICKED(IDC_BUTTON_PopCard, &CRIDBMTReaderDlg::OnBnClickedButtonPopcard)
END_MESSAGE_MAP()


// CRIDBMTReaderDlg message handlers

BOOL CRIDBMTReaderDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	std::string strport = getConfig("PORT");


	CString strCom[255];
	CString strTemp;
	CString strPort;

	HANDLE hCom;
	int index = 0;
	for (int i = 0; i<255; i++)
	{
		strTemp.Format("\\\\.\\COM%d", i + 1);
		strPort.Format("%d", i + 1);
		hCom = CreateFile(strTemp, GENERIC_READ | GENERIC_WRITE, 0, NULL,
			OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);
		if (INVALID_HANDLE_VALUE == hCom)
			continue;


		strCom[i] = strTemp;
		CB_Port.AddString(strPort);


		if (string(strPort.GetString()) == strport)
		{
			CB_Port.SetCurSel(index);
		}

		index++;

		CloseHandle(hCom);
	}




	com.linkRichEdit(&m_richedit);
	com.setparentdlg(this);


	if (strport != "" || strport != "0")
	{
		OnBnClickedButtonOpenport();
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRIDBMTReaderDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRIDBMTReaderDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CRIDBMTReaderDlg::OnBnClickedButtonOpenport()
{
	int portno = 0;

	CString strport;
	GetDlgItem(IDC_COMBO1)->GetWindowText(strport);

	portno = atoi(strport.GetString());

	com.opencom(portno);

	saveConfig("PORT", strport.GetString());
}


void CRIDBMTReaderDlg::addText(string str)
{
	m_richedit.SetSel(-1, -1);
	m_richedit.ReplaceSel((str + string("\r\n")).c_str());
	m_richedit.PostMessage(WM_VSCROLL, SB_BOTTOM, 0);
}


void CRIDBMTReaderDlg::OnBnClickedButtonCleartrade()
{


	g_stage = 1;
	sendStageData();
}

void CRIDBMTReaderDlg::sendStageData()
{
	CString szInfo;

	if (g_stage == 0)
	{
		return;
	}
	else if (g_stage == 1)
	{

		addText("ѯ״̬");
		szInfo = "020002314103";

	}
	else if (g_stage == 2)
	{
		addText("CPU临λϵ磩");
		szInfo = "020002374003";
	}
	else if (g_stage == 3)
	{
		addText("select adf");
		string apdu = "00A404000E315041592E5359532E444446303100";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 4)
	{
		addText("select ET1");
		string apdu = "00a404000ca00000000353494e4f50454300";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 5)
	{
		addText("21ļ");
		string apdu = "00b095001e";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 6)
	{
		addText("26ļ");
		string apdu = "00b09a0029";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 7)
	{
		addText("verify");
		string apdu = "0020000002999900";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 8)
	{
		addText("ѯ¼ֵ");
		string apdu = "80B8000002";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 9)
	{
		addText("ѯδ¼");
		string apdu = "80B8010002";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 10)
	{
		addText("¼");
		string apdu = "80BA0100020000";
		int len = apdu.size() / 2;
		char chlen1[3] = { 0 };
		char chlen2[3] = { 0 };
		sprintf_s(chlen1, "%.2x", len + 4);
		sprintf_s(chlen2, "%.2x", len);

		szInfo = "0200" + CString(chlen1) + "374300" + CString(chlen2) + apdu.c_str() + "03";
		szInfo = szInfo;
	}
	else if (g_stage == 11)
	{
		addText("");
		szInfo = "020002324003";
	}




	g_enq = 0;


	BYTE tmpbuf[512] = { 0 };
	int szlen = szInfo.GetLength();
	for (int i = 0; i <= szlen / 2; i++)
	{
		string str = szInfo.Mid(i * 2, 2);

		tmpbuf[i] = strtol(str.c_str(), NULL, 16);
	}

	unsigned char xor = XORChecksum(tmpbuf, szlen / 2);
	char chxor[3];
	sprintf_s(chxor, "%02x", xor);
	szInfo += chxor;


	BYTE buff[1024];
	memset(buff, 0, 1024);
	int sendlen = szInfo.GetLength();
	for (int i = 0; i < sendlen; ++i)
	{
		CString str = szInfo.Mid(i * 2, 2);
		sscanf_s(str, "%02x", &buff[i]);
	}
	com.senddata(buff, sendlen / 2);
}



void CRIDBMTReaderDlg::OnBnClickedButtonPopcard()
{


	CString szInfo;


	addText("");
	szInfo = "020002324003";

	g_enq = 0;


	BYTE tmpbuf[512] = { 0 };
	int szlen = szInfo.GetLength();
	for (int i = 0; i <= szlen / 2; i++)
	{
		string str = szInfo.Mid(i * 2, 2);

		tmpbuf[i] = strtol(str.c_str(), NULL, 16);
	}

	unsigned char xor = XORChecksum(tmpbuf, szlen / 2);
	char chxor[3];
	sprintf_s(chxor, "%02x", xor);
	szInfo += chxor;


	BYTE buff[1024];
	memset(buff, 0, 1024);
	int sendlen = szInfo.GetLength();
	for (int i = 0; i < sendlen; ++i)
	{
		CString str = szInfo.Mid(i * 2, 2);
		sscanf_s(str, "%02x", &buff[i]);
	}
	com.senddata(buff, sendlen / 2);
}
